#pragma semicolon 1

#include <ws_store>
#include <sourcemod>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "STORE (Bhop)",
	author	= "wS (World-Source.Ru)",
	version = "1.2"
};

new g_Price, g_Minutes, g_CategoryID, g_ItemID;
new Handle:g_hTrie, g_BhopTime[MAXPLAYERS + 1];
new LastMenuItem:MI;
new bool:g_bCanJump[MAXPLAYERS + 1] = {true, ...};

public OnPluginStart()
{
	g_hTrie = CreateTrie();
	CreateTimer(1.0, START);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_bhop");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_bhop.txt"))
		SetFailState("Error in cfg/store/modules/store_bhop.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	if ((g_Minutes = KvGetNum(kv, "minutes")) < 1) g_Minutes = 1;
	MI = g_ItemID > 0 ? MI_InCategory : MI_Main;

	CloseHandle(kv);
	/////

	HookEvent("player_spawn", player_spawn, EventHookMode_Pre);
	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID) wS_OnClientSelect(client);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID) wS_OnClientSelect(client);
}

stock wS_OnClientSelect(client)
{
	new CurrTime = GetTime();

	if (g_BhopTime[client] > 0 && g_BhopTime[client] > CurrTime)
	{
		wS_ShowTimePanel(client, (g_BhopTime[client] - CurrTime));
		return;
	}

	g_BhopTime[client] = 0;

	decl String:steamid[30];
	if (!GetClientAuthString(client, steamid, 30))
		return;

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_BhopTime[client] = g_Minutes * 60 + CurrTime;
	SetTrieValue(g_hTrie, steamid, g_BhopTime[client], true);
	PrintToChat(client, "\x04Теперь вы можете использовать распрыжку");

	wS_ShowTimePanel(client, (g_BhopTime[client] - CurrTime));
}

stock wS_ShowTimePanel(client, const S)
{
	new Handle:panel = CreatePanel();
	decl String:text[125];
	Format(text, 125, "Отключится через: %dч %dм %dс", S / 3600, S / 60 % 60, S % 60);
	DrawPanelText(panel, text);
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	SendPanelToClient(panel, client, wS_ShowTimePanel_CallBack, 0);
	CloseHandle(panel);
}

public wS_ShowTimePanel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select) STORE_ShowMenu(client, MI);
}


///


public OnClientConnected(client)  g_BhopTime[client] = 0;
public OnClientDisconnect(client) g_BhopTime[client] = 0;

public OnClientAuthorized(client, const String:steamid[])
{
	if (GetTrieValue(g_hTrie, steamid, g_BhopTime[client]) && 0 < g_BhopTime[client] <= GetTime())
	{
		g_BhopTime[client] = 0;
		if (!RemoveFromTrie(g_hTrie, steamid)) SetTrieValue(g_hTrie, steamid, 0, true);
	}
}

public Action:player_spawn(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	g_bCanJump[client] = false;

	if (g_BhopTime[client] < 1)
		return Plugin_Continue;

	if (g_BhopTime[client] <= GetTime())
	{
		g_BhopTime[client] = 0;
		PrintToChat(client, "\x04Распрыжка отключена (время истекло)");

		decl String:steamid[30];
		if (GetClientAuthString(client, steamid, 30))
		{
			if (!RemoveFromTrie(g_hTrie, steamid)) SetTrieValue(g_hTrie, steamid, 0, true);
		}
	}

	return Plugin_Continue;
}


///


public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (buttons & IN_JUMP)
	{
		if (g_BhopTime[client] > 0 && g_bCanJump[client] && IsPlayerAlive(client) && GetEntProp(client, Prop_Send, "m_nWaterLevel") < 2)
		{
			if (GetEntityFlags(client) & FL_ONGROUND)
			{
				decl Float:Vec[3], Float:Vel[3];
				GetClientEyeAngles(client, Vec);
				Vec[0] = 0.0;
				GetAngleVectors(Vec, Vec, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(Vec, Vec);
				ScaleVector(Vec, 50.0);
				GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", Vel);
				Vel[0] += Vec[0];
				Vel[1] += Vec[1];
				Vel[2] += Vec[2];
				TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, Vel);
			}
			else
				buttons &= ~IN_JUMP;
		}
	}
	else
		g_bCanJump[client] = true;

	return Plugin_Continue;
}